Index: loader/source/update-simple.c
===================================================================
--- loader/source/update-simple.c	(nonexistent)
+++ loader/source/update-simple.c	(working copy)
@@ -0,0 +1,786 @@
+/*
+
+Nintendont (Loader) - Playing Gamecubes in Wii mode on a Wii U
+
+Copyright (C) 2014  JoostinOnline
+
+This program is free software; you can redistribute it and/or
+modify it under the terms of the GNU General Public License
+as published by the Free Software Foundation version 2.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program; if not, write to the Free Software
+Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+
+*/
+
+#include <gccore.h>
+#include <string.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <unistd.h>
+#include <malloc.h>
+#include <network.h>
+
+#include <zlib.h>
+#include <ogc/lwp_watchdog.h>
+
+#include "exi.h"
+#include "FPad.h"
+#include "font.h"
+#include "global.h"
+#include "http.h"
+#include "menu.h"
+#include "update.h"
+#include "../../common/include/NintendontVersion.h"
+
+#include "ff_utf8.h"
+#include "unzip/miniunz.h"
+#include "unzip/ioapi.h"
+extern void changeToDefaultDrive();
+extern char launch_dir[MAXPATHLEN];
+extern int selected;
+
+typedef struct {
+	const char url[96];
+	const char text[30];
+	const char filename[30];
+	const u32 max_size;
+} downloads_t;
+
+typedef enum {
+	DOWNLOAD_00,
+	DOWNLOAD_01,
+	DOWNLOAD_02,
+	DOWNLOAD_03,
+	DOWNLOAD_04,
+	DOWNLOAD_05,
+	DOWNLOAD_06,
+	DOWNLOAD_07,
+	DOWNLOAD_08,
+	DOWNLOAD_09,
+	DOWNLOAD_10,
+	DOWNLOAD_11,
+	DOWNLOAD_12,
+	DOWNLOAD_13,
+	DOWNLOAD_14,
+	DOWNLOAD_15
+} DOWNLOADS;
+
+static const downloads_t Downloads[] = {
+	{"http://send0r.de/Nintendont/MasterMod/000.zip", "Downloading Black Theme", "000.zip", 0x80000}, // 512KB
+	{"http://send0r.de/Nintendont/MasterMod/001.zip", "Downloading Black Theme", "001.zip", 0x80000}, // 512KB	
+	{"http://send0r.de/Nintendont/MasterMod/002.zip", "Downloading Black Theme", "002.zip", 0x80000}, // 512KB
+	{"http://send0r.de/Nintendont/MasterMod/003.zip", "Downloading Black Theme", "003.zip", 0x80000}, // 512KB
+	{"http://send0r.de/Nintendont/MasterMod/004.zip", "Downloading Black Theme", "004.zip", 0x80000}, // 512KB	
+	{"http://send0r.de/Nintendont/MasterMod/005.zip", "Downloading Black Theme", "005.zip", 0x80000}, // 512KB
+	{"http://send0r.de/Nintendont/MasterMod/006.zip", "Downloading Black Theme", "006.zip", 0x80000}, // 512KB	
+	{"http://send0r.de/Nintendont/MasterMod/007.zip", "Downloading Black Theme", "007.zip", 0x80000}, // 512KB
+	{"http://send0r.de/Nintendont/MasterMod/008.zip", "Downloading Black Theme", "008.zip", 0x80000}, // 512KB	
+	{"http://send0r.de/Nintendont/MasterMod/009.zip", "Downloading Black Theme", "009.zip", 0x80000}, // 512KB
+	{"http://send0r.de/Nintendont/MasterMod/010.zip", "Downloading Black Theme", "010.zip", 0x80000}, // 512KB
+	{"http://send0r.de/Nintendont/MasterMod/011.zip", "Downloading Black Theme", "011.zip", 0x80000}, // 512KB
+	{"http://send0r.de/Nintendont/MasterMod/012.zip", "Downloading Black Theme", "012.zip", 0x80000}, // 512KB
+	{"http://send0r.de/Nintendont/MasterMod/013.zip", "Downloading Black Theme", "013.zip", 0x80000}, // 512KB
+	{"http://send0r.de/Nintendont/MasterMod/014.zip", "Downloading Black Theme", "014.zip", 0x80000}, // 512KB
+	{"http://send0r.de/Nintendont/MasterMod/015.zip", "Downloading Black Theme", "015.zip", 0x80000}, // 512KB
+};
+
+static int Unzip00(const void *buf, size_t fSize) {
+	char filepath[20];
+	snprintf(filepath,20,"%x+%x",(u32)buf,(u32)fSize);
+	 static const char *unzip_directory = "/apps/Nintendont";
+	unzFile uf = unzOpen(filepath);
+	if (!uf) {
+		gprintf("Cannot open %s, aborting\r\n", Downloads[DOWNLOAD_00].filename);
+		return -1;
+	}
+	gprintf("%s opened\n", Downloads[DOWNLOAD_00].filename);
+	
+	changeToDefaultDrive();
+	f_chdir_char("/apps/Nintendont");
+	if(f_chdir_char(unzip_directory) != FR_OK) {
+		gprintf("Error changing into %s, aborting\r\n", unzip_directory);
+		return -2;
+	}
+
+	if (extractZip(uf,0,1,0)) {
+		gprintf("Failed to extract %s\r\n", filepath);
+		return -3;
+	}
+
+	unzCloseCurrentFile(uf);
+	f_unlink_char(Downloads[DOWNLOAD_00].filename);
+	changeToDefaultDrive();
+	return 1;
+}
+
+static int Unzip01(const void *buf, size_t fSize) {
+	char filepath[20];
+	snprintf(filepath,20,"%x+%x",(u32)buf,(u32)fSize);
+	 static const char *unzip_directory = "/apps/Nintendont";
+	unzFile uf = unzOpen(filepath);
+	if (!uf) {
+		gprintf("Cannot open %s, aborting\r\n", Downloads[DOWNLOAD_01].filename);
+		return -1;
+	}
+	gprintf("%s opened\n", Downloads[DOWNLOAD_01].filename);
+	
+	changeToDefaultDrive();
+	f_chdir_char("/apps/Nintendont");
+	if(f_chdir_char(unzip_directory) != FR_OK) {
+		gprintf("Error changing into %s, aborting\r\n", unzip_directory);
+		return -2;
+	}
+
+	if (extractZip(uf,0,1,0)) {
+		gprintf("Failed to extract %s\r\n", filepath);
+		return -3;
+	}
+
+	unzCloseCurrentFile(uf);
+	f_unlink_char(Downloads[DOWNLOAD_01].filename);
+	changeToDefaultDrive();
+	return 1;
+}
+
+static int Unzip02(const void *buf, size_t fSize) {
+	char filepath[20];
+	snprintf(filepath,20,"%x+%x",(u32)buf,(u32)fSize);
+	 static const char *unzip_directory = "/apps/Nintendont";
+	unzFile uf = unzOpen(filepath);
+	if (!uf) {
+		gprintf("Cannot open %s, aborting\r\n", Downloads[DOWNLOAD_02].filename);
+		return -1;
+	}
+	gprintf("%s opened\n", Downloads[DOWNLOAD_02].filename);
+	
+	changeToDefaultDrive();
+	f_chdir_char("/apps/Nintendont");
+	if(f_chdir_char(unzip_directory) != FR_OK) {
+		gprintf("Error changing into %s, aborting\r\n", unzip_directory);
+		return -2;
+	}
+
+	if (extractZip(uf,0,1,0)) {
+		gprintf("Failed to extract %s\r\n", filepath);
+		return -3;
+	}
+
+	unzCloseCurrentFile(uf);
+	f_unlink_char(Downloads[DOWNLOAD_02].filename);
+	changeToDefaultDrive();
+	return 1;
+}
+
+static int Unzip03(const void *buf, size_t fSize) {
+	char filepath[20];
+	snprintf(filepath,20,"%x+%x",(u32)buf,(u32)fSize);
+	 static const char *unzip_directory = "/apps/Nintendont";
+	unzFile uf = unzOpen(filepath);
+	if (!uf) {
+		gprintf("Cannot open %s, aborting\r\n", Downloads[DOWNLOAD_03].filename);
+		return -1;
+	}
+	gprintf("%s opened\n", Downloads[DOWNLOAD_03].filename);
+	
+	changeToDefaultDrive();
+	f_chdir_char("/apps/Nintendont");
+	if(f_chdir_char(unzip_directory) != FR_OK) {
+		gprintf("Error changing into %s, aborting\r\n", unzip_directory);
+		return -2;
+	}
+
+	if (extractZip(uf,0,1,0)) {
+		gprintf("Failed to extract %s\r\n", filepath);
+		return -3;
+	}
+
+	unzCloseCurrentFile(uf);
+	f_unlink_char(Downloads[DOWNLOAD_03].filename);
+	changeToDefaultDrive();
+	return 1;
+}
+
+static int Unzip04(const void *buf, size_t fSize) {
+	char filepath[20];
+	snprintf(filepath,20,"%x+%x",(u32)buf,(u32)fSize);
+	 static const char *unzip_directory = "/apps/Nintendont";
+	unzFile uf = unzOpen(filepath);
+	if (!uf) {
+		gprintf("Cannot open %s, aborting\r\n", Downloads[DOWNLOAD_04].filename);
+		return -1;
+	}
+	gprintf("%s opened\n", Downloads[DOWNLOAD_04].filename);
+	
+	changeToDefaultDrive();
+	f_chdir_char("/apps/Nintendont");
+	if(f_chdir_char(unzip_directory) != FR_OK) {
+		gprintf("Error changing into %s, aborting\r\n", unzip_directory);
+		return -2;
+	}
+
+	if (extractZip(uf,0,1,0)) {
+		gprintf("Failed to extract %s\r\n", filepath);
+		return -3;
+	}
+
+	unzCloseCurrentFile(uf);
+	f_unlink_char(Downloads[DOWNLOAD_04].filename);
+	changeToDefaultDrive();
+	return 1;
+}
+
+static int Unzip05(const void *buf, size_t fSize) {
+	char filepath[20];
+	snprintf(filepath,20,"%x+%x",(u32)buf,(u32)fSize);
+	 static const char *unzip_directory = "/apps/Nintendont";
+	unzFile uf = unzOpen(filepath);
+	if (!uf) {
+		gprintf("Cannot open %s, aborting\r\n", Downloads[DOWNLOAD_05].filename);
+		return -1;
+	}
+	gprintf("%s opened\n", Downloads[DOWNLOAD_05].filename);
+	
+	changeToDefaultDrive();
+	f_chdir_char("/apps/Nintendont");
+	if(f_chdir_char(unzip_directory) != FR_OK) {
+		gprintf("Error changing into %s, aborting\r\n", unzip_directory);
+		return -2;
+	}
+
+	if (extractZip(uf,0,1,0)) {
+		gprintf("Failed to extract %s\r\n", filepath);
+		return -3;
+	}
+
+	unzCloseCurrentFile(uf);
+	f_unlink_char(Downloads[DOWNLOAD_05].filename);
+	changeToDefaultDrive();
+	return 1;
+}
+
+static int Unzip06(const void *buf, size_t fSize) {
+	char filepath[20];
+	snprintf(filepath,20,"%x+%x",(u32)buf,(u32)fSize);
+	 static const char *unzip_directory = "/apps/Nintendont";
+	unzFile uf = unzOpen(filepath);
+	if (!uf) {
+		gprintf("Cannot open %s, aborting\r\n", Downloads[DOWNLOAD_06].filename);
+		return -1;
+	}
+	gprintf("%s opened\n", Downloads[DOWNLOAD_06].filename);
+	
+	changeToDefaultDrive();
+	f_chdir_char("/apps/Nintendont");
+	if(f_chdir_char(unzip_directory) != FR_OK) {
+		gprintf("Error changing into %s, aborting\r\n", unzip_directory);
+		return -2;
+	}
+
+	if (extractZip(uf,0,1,0)) {
+		gprintf("Failed to extract %s\r\n", filepath);
+		return -3;
+	}
+
+	unzCloseCurrentFile(uf);
+	f_unlink_char(Downloads[DOWNLOAD_06].filename);
+	changeToDefaultDrive();
+	return 1;
+}
+
+static int Unzip07(const void *buf, size_t fSize) {
+	char filepath[20];
+	snprintf(filepath,20,"%x+%x",(u32)buf,(u32)fSize);
+	 static const char *unzip_directory = "/apps/Nintendont";
+	unzFile uf = unzOpen(filepath);
+	if (!uf) {
+		gprintf("Cannot open %s, aborting\r\n", Downloads[DOWNLOAD_07].filename);
+		return -1;
+	}
+	gprintf("%s opened\n", Downloads[DOWNLOAD_07].filename);
+	
+	changeToDefaultDrive();
+	f_chdir_char("/apps/Nintendont");
+	if(f_chdir_char(unzip_directory) != FR_OK) {
+		gprintf("Error changing into %s, aborting\r\n", unzip_directory);
+		return -2;
+	}
+
+	if (extractZip(uf,0,1,0)) {
+		gprintf("Failed to extract %s\r\n", filepath);
+		return -3;
+	}
+
+	unzCloseCurrentFile(uf);
+	f_unlink_char(Downloads[DOWNLOAD_07].filename);
+	changeToDefaultDrive();
+	return 1;
+}
+
+static int Unzip08(const void *buf, size_t fSize) {
+	char filepath[20];
+	snprintf(filepath,20,"%x+%x",(u32)buf,(u32)fSize);
+	 static const char *unzip_directory = "/apps/Nintendont";
+	unzFile uf = unzOpen(filepath);
+	if (!uf) {
+		gprintf("Cannot open %s, aborting\r\n", Downloads[DOWNLOAD_08].filename);
+		return -1;
+	}
+	gprintf("%s opened\n", Downloads[DOWNLOAD_08].filename);
+	
+	changeToDefaultDrive();
+	f_chdir_char("/apps/Nintendont");
+	if(f_chdir_char(unzip_directory) != FR_OK) {
+		gprintf("Error changing into %s, aborting\r\n", unzip_directory);
+		return -2;
+	}
+
+	if (extractZip(uf,0,1,0)) {
+		gprintf("Failed to extract %s\r\n", filepath);
+		return -3;
+	}
+
+	unzCloseCurrentFile(uf);
+	f_unlink_char(Downloads[DOWNLOAD_08].filename);
+	changeToDefaultDrive();
+	return 1;
+}
+
+static int Unzip09(const void *buf, size_t fSize) {
+	char filepath[20];
+	snprintf(filepath,20,"%x+%x",(u32)buf,(u32)fSize);
+	 static const char *unzip_directory = "/apps/Nintendont";
+	unzFile uf = unzOpen(filepath);
+	if (!uf) {
+		gprintf("Cannot open %s, aborting\r\n", Downloads[DOWNLOAD_09].filename);
+		return -1;
+	}
+	gprintf("%s opened\n", Downloads[DOWNLOAD_09].filename);
+	
+	changeToDefaultDrive();
+	f_chdir_char("/apps/Nintendont");
+	if(f_chdir_char(unzip_directory) != FR_OK) {
+		gprintf("Error changing into %s, aborting\r\n", unzip_directory);
+		return -2;
+	}
+
+	if (extractZip(uf,0,1,0)) {
+		gprintf("Failed to extract %s\r\n", filepath);
+		return -3;
+	}
+
+	unzCloseCurrentFile(uf);
+	f_unlink_char(Downloads[DOWNLOAD_09].filename);
+	changeToDefaultDrive();
+	return 1;
+}
+
+static int Unzip10(const void *buf, size_t fSize) {
+	char filepath[20];
+	snprintf(filepath,20,"%x+%x",(u32)buf,(u32)fSize);
+	 static const char *unzip_directory = "/apps/Nintendont";
+	unzFile uf = unzOpen(filepath);
+	if (!uf) {
+		gprintf("Cannot open %s, aborting\r\n", Downloads[DOWNLOAD_10].filename);
+		return -1;
+	}
+	gprintf("%s opened\n", Downloads[DOWNLOAD_10].filename);
+	
+	changeToDefaultDrive();
+	f_chdir_char("/apps/Nintendont");
+	if(f_chdir_char(unzip_directory) != FR_OK) {
+		gprintf("Error changing into %s, aborting\r\n", unzip_directory);
+		return -2;
+	}
+
+	if (extractZip(uf,0,1,0)) {
+		gprintf("Failed to extract %s\r\n", filepath);
+		return -3;
+	}
+
+	unzCloseCurrentFile(uf);
+	f_unlink_char(Downloads[DOWNLOAD_10].filename);
+	changeToDefaultDrive();
+	return 1;
+}
+
+static int Unzip11(const void *buf, size_t fSize) {
+	char filepath[20];
+	snprintf(filepath,20,"%x+%x",(u32)buf,(u32)fSize);
+	 static const char *unzip_directory = "/apps/Nintendont";
+	unzFile uf = unzOpen(filepath);
+	if (!uf) {
+		gprintf("Cannot open %s, aborting\r\n", Downloads[DOWNLOAD_11].filename);
+		return -1;
+	}
+	gprintf("%s opened\n", Downloads[DOWNLOAD_11].filename);
+	
+	changeToDefaultDrive();
+	f_chdir_char("/apps/Nintendont");
+	if(f_chdir_char(unzip_directory) != FR_OK) {
+		gprintf("Error changing into %s, aborting\r\n", unzip_directory);
+		return -2;
+	}
+
+	if (extractZip(uf,0,1,0)) {
+		gprintf("Failed to extract %s\r\n", filepath);
+		return -3;
+	}
+
+	unzCloseCurrentFile(uf);
+	f_unlink_char(Downloads[DOWNLOAD_11].filename);
+	changeToDefaultDrive();
+	return 1;
+}
+
+static int Unzip12(const void *buf, size_t fSize) {
+	char filepath[20];
+	snprintf(filepath,20,"%x+%x",(u32)buf,(u32)fSize);
+	 static const char *unzip_directory = "/apps/Nintendont";
+	unzFile uf = unzOpen(filepath);
+	if (!uf) {
+		gprintf("Cannot open %s, aborting\r\n", Downloads[DOWNLOAD_12].filename);
+		return -1;
+	}
+	gprintf("%s opened\n", Downloads[DOWNLOAD_12].filename);
+	
+	changeToDefaultDrive();
+	f_chdir_char("/apps/Nintendont");
+	if(f_chdir_char(unzip_directory) != FR_OK) {
+		gprintf("Error changing into %s, aborting\r\n", unzip_directory);
+		return -2;
+	}
+
+	if (extractZip(uf,0,1,0)) {
+		gprintf("Failed to extract %s\r\n", filepath);
+		return -3;
+	}
+
+	unzCloseCurrentFile(uf);
+	f_unlink_char(Downloads[DOWNLOAD_12].filename);
+	changeToDefaultDrive();
+	return 1;
+}
+
+static int Unzip13(const void *buf, size_t fSize) {
+	char filepath[20];
+	snprintf(filepath,20,"%x+%x",(u32)buf,(u32)fSize);
+	 static const char *unzip_directory = "/apps/Nintendont";
+	unzFile uf = unzOpen(filepath);
+	if (!uf) {
+		gprintf("Cannot open %s, aborting\r\n", Downloads[DOWNLOAD_13].filename);
+		return -1;
+	}
+	gprintf("%s opened\n", Downloads[DOWNLOAD_13].filename);
+	
+	changeToDefaultDrive();
+	f_chdir_char("/apps/Nintendont");
+	if(f_chdir_char(unzip_directory) != FR_OK) {
+		gprintf("Error changing into %s, aborting\r\n", unzip_directory);
+		return -2;
+	}
+
+	if (extractZip(uf,0,1,0)) {
+		gprintf("Failed to extract %s\r\n", filepath);
+		return -3;
+	}
+
+	unzCloseCurrentFile(uf);
+	f_unlink_char(Downloads[DOWNLOAD_13].filename);
+	changeToDefaultDrive();
+	return 1;
+}
+
+static int Unzip14(const void *buf, size_t fSize) {
+	char filepath[20];
+	snprintf(filepath,20,"%x+%x",(u32)buf,(u32)fSize);
+	 static const char *unzip_directory = "/apps/Nintendont";
+	unzFile uf = unzOpen(filepath);
+	if (!uf) {
+		gprintf("Cannot open %s, aborting\r\n", Downloads[DOWNLOAD_14].filename);
+		return -1;
+	}
+	gprintf("%s opened\n", Downloads[DOWNLOAD_14].filename);
+	
+	changeToDefaultDrive();
+	f_chdir_char("/apps/Nintendont");
+	if(f_chdir_char(unzip_directory) != FR_OK) {
+		gprintf("Error changing into %s, aborting\r\n", unzip_directory);
+		return -2;
+	}
+
+	if (extractZip(uf,0,1,0)) {
+		gprintf("Failed to extract %s\r\n", filepath);
+		return -3;
+	}
+
+	unzCloseCurrentFile(uf);
+	f_unlink_char(Downloads[DOWNLOAD_14].filename);
+	changeToDefaultDrive();
+	return 1;
+}
+
+static int Unzip15(const void *buf, size_t fSize) {
+	char filepath[20];
+	snprintf(filepath,20,"%x+%x",(u32)buf,(u32)fSize);
+	 static const char *unzip_directory = "/apps/Nintendont";
+	unzFile uf = unzOpen(filepath);
+	if (!uf) {
+		gprintf("Cannot open %s, aborting\r\n", Downloads[DOWNLOAD_15].filename);
+		return -1;
+	}
+	gprintf("%s opened\n", Downloads[DOWNLOAD_15].filename);
+	
+	changeToDefaultDrive();
+	f_chdir_char("/apps/Nintendont");
+	if(f_chdir_char(unzip_directory) != FR_OK) {
+		gprintf("Error changing into %s, aborting\r\n", unzip_directory);
+		return -2;
+	}
+
+	if (extractZip(uf,0,1,0)) {
+		gprintf("Failed to extract %s\r\n", filepath);
+		return -3;
+	}
+
+	unzCloseCurrentFile(uf);
+	f_unlink_char(Downloads[DOWNLOAD_15].filename);
+	changeToDefaultDrive();
+	return 1;
+}
+
+static s32 Download(DOWNLOADS download_number)  {
+	ClearScreen();
+	
+	int line = 1;
+	int ret;
+	u32 http_status = 0;
+	u8* outbuf = NULL;
+	u32 filesize;
+	char filepath[MAXPATHLEN];
+	bool dir_argument_exists = strlen(launch_dir);
+	snprintf(filepath, sizeof(filepath), "%s%s", dir_argument_exists ? launch_dir : "/apps/Nintendont/", Downloads[download_number].filename);
+	if (which_bg == BG_NONE)
+					{PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X, MENU_POS_Y + 20*line, Downloads[download_number].text);}
+					else if (which_bg == BG_LEGACY)
+					{PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X, MENU_POS_Y + 20*line, Downloads[download_number].text);}
+	UpdateScreen();
+	
+	line++;
+	gprintf("Downloading %s to %s\r\n", Downloads[download_number].url, filepath);
+	ret = net_init();
+	if(ret < 0) {
+		gprintf("Failed to init network\r\n");
+		goto end;
+	}
+	gprintf("Network Initialized\r\n");
+	if (which_bg == BG_NONE)
+					{PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X, MENU_POS_Y + 20*line, "Network Initialized");}
+					else if (which_bg == BG_LEGACY)
+					{PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X, MENU_POS_Y + 20*line, "Network Initialized");}
+	UpdateScreen();
+	
+	int i;
+	for (i = 0; i <= 10; i++) {
+		ret = http_request(Downloads[download_number].url, Downloads[download_number].max_size);
+		if (ret) break;
+		if (i == 10) {
+			gprintf("Error making http request\r\n");
+			ret = -1;
+			goto end;
+		}
+	}
+
+	ret = http_get_result(&http_status, &outbuf, &filesize); 
+	if(((int)*outbuf & 0xF0000000) == 0xF0000000) 
+	{
+		ret = -2;
+		goto end;
+	}
+
+	UpdateScreen();
+	line++;
+	if (!dir_argument_exists) {
+		gprintf("Creating new directory\r\n");
+		f_mkdir_char("/apps/Nintendont");
+	}
+		if (download_number == DOWNLOAD_00) {ret = Unzip00(outbuf, filesize);}
+		else if (download_number == DOWNLOAD_01) {ret = Unzip01(outbuf, filesize);}
+		else if (download_number == DOWNLOAD_02) {ret = Unzip02(outbuf, filesize);}
+		else if (download_number == DOWNLOAD_03) {ret = Unzip03(outbuf, filesize);}
+		else if (download_number == DOWNLOAD_04) {ret = Unzip04(outbuf, filesize);}
+		else if (download_number == DOWNLOAD_05) {ret = Unzip05(outbuf, filesize);}
+		else if (download_number == DOWNLOAD_06) {ret = Unzip06(outbuf, filesize);}
+		else if (download_number == DOWNLOAD_07) {ret = Unzip07(outbuf, filesize);}
+		else if (download_number == DOWNLOAD_08) {ret = Unzip08(outbuf, filesize);}
+		else if (download_number == DOWNLOAD_09) {ret = Unzip09(outbuf, filesize);}
+		else if (download_number == DOWNLOAD_10) {ret = Unzip10(outbuf, filesize);}
+		else if (download_number == DOWNLOAD_11) {ret = Unzip11(outbuf, filesize);}
+		else if (download_number == DOWNLOAD_12) {ret = Unzip12(outbuf, filesize);}
+		else if (download_number == DOWNLOAD_13) {ret = Unzip13(outbuf, filesize);}
+		else if (download_number == DOWNLOAD_14) {ret = Unzip14(outbuf, filesize);}
+		else if (download_number == DOWNLOAD_15) {ret = Unzip15(outbuf, filesize);}
+else
+	{
+		FIL file;
+		if (f_open_char(&file, filepath, FA_WRITE|FA_CREATE_ALWAYS) != FR_OK) {
+			gprintf("File Error\r\n");
+			ret = -3;
+			goto end;
+		} else {
+			UINT wrote;
+			f_write(&file, outbuf, filesize, &wrote);
+			f_close(&file);
+			ret = 1;			
+		}
+	}
+	if (ret == 1) {
+										if (which_bg == BG_NONE)
+					{PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X, MENU_POS_Y + 20*line, "Update Complete");}
+					else if (which_bg == BG_LEGACY)
+					{PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X, MENU_POS_Y + 20*line, "Update Complete");}
+		UpdateScreen();
+		line++;
+	}
+	end:
+	if (ret != 1)
+		{
+			if (which_bg == BG_NONE)
+			PrintFormat(DEFAULT_SIZE, MAROON, MENU_POS_X, MENU_POS_Y + 20*(line+1), "Update Error: %i", ret);
+			else if (which_bg == BG_LEGACY)
+			PrintFormat(DEFAULT_SIZE, YELLOW, MENU_POS_X, MENU_POS_Y + 20*(line+1), "Update Error: %i", ret);
+			f_rename_char( "./NinBack.old", "./NinBack.png");
+			f_rename_char( "./NinBlack.old", "./NinBlack.png");
+			f_rename_char( "./NinLegacy.old", "./NinLegacy.png");
+			UpdateScreen();
+			if (outbuf != NULL) free(outbuf);
+			net_deinit();
+			sleep(2);
+			return ret;
+		}
+	else {
+	if (which_bg == BG_NONE)
+	{PrintFormat(37, 0x80000000, MENU_POS_X, MENU_POS_Y + 20*(line+15), "Applying The New Theme Now");}
+	else if (which_bg == BG_LEGACY)
+	{PrintFormat(37, WHITE, MENU_POS_X, MENU_POS_Y + 20*(line+15), "Applying The New Theme Now");}}
+	UpdateScreen();
+	if (outbuf != NULL) free(outbuf);
+	net_deinit();
+	sleep(2);
+	BackTheme();
+	return ret;
+}
+
+void SimpleBack(void) {
+	selected = 0;
+	u64 delay = ticks_to_millisecs(gettime()) + 500;
+	while(true) {
+	end:
+		ClearScreen();
+		if (which_bg == BG_NONE)
+					{		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 430, MENU_POS_Y, "  Home: Exit");
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 430, MENU_POS_Y + 20*1, "  A   : Select");
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 430, MENU_POS_Y + 20*2, "  B   : Back");	
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X, MENU_POS_Y + 20*2, "Black Themes Menu");	
+		PrintFormat(15, BLACK, MENU_POS_X + 235, MENU_POS_Y + 20*21, "Y/2: Credits");	
+		PrintInfo();
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 50, MENU_POS_Y + 20*4, "Stormy Night Theme");
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 50, MENU_POS_Y + 20*5, "Dark Fog Theme");
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 50, MENU_POS_Y + 20*6, "No Hope Theme");
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 50, MENU_POS_Y + 20*7, "Versace Theme");		
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 50, MENU_POS_Y + 20*8, "Old As Hell Theme");
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 50, MENU_POS_Y + 20*9, "No Escape Theme");
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 50, MENU_POS_Y + 20*10, "Mild Hope Theme");
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 50, MENU_POS_Y + 20*11, "Lonely Flowers Theme");
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 50, MENU_POS_Y + 20*12, "Power Grid Theme");			
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 50, MENU_POS_Y + 20*13, "Future Door Theme");
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 50, MENU_POS_Y + 20*14, "Old Paper Theme");
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 50, MENU_POS_Y + 20*15, "Doom's Hive Theme");
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 50, MENU_POS_Y + 20*16, "Crazy Wall Theme");
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 50, MENU_POS_Y + 20*17, "Classic Curves Theme");
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 50, MENU_POS_Y + 20*18, "Super Nova Theme");
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 50, MENU_POS_Y + 20*19, "Mosaic Theme");
+	
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 35, MENU_POS_Y + 20*(4+selected), ARROW_RIGHT);}
+					else if (which_bg == BG_LEGACY)
+					{		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 430, MENU_POS_Y, "  Home: Exit");
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 430, MENU_POS_Y + 20*1, "  A   : Select");
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 430, MENU_POS_Y + 20*2, "  B   : Back");	
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X, MENU_POS_Y + 20*2, "Black Themes Menu");		
+		PrintFormat(15, WHITE, MENU_POS_X + 235, MENU_POS_Y + 20*21, "Y/2: Credits");	
+		PrintInfo();
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 50, MENU_POS_Y + 20*4, "Stormy Night Theme");
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 50, MENU_POS_Y + 20*5, "Dark Fog Theme");
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 50, MENU_POS_Y + 20*6, "No Hope Theme");
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 50, MENU_POS_Y + 20*7, "Versace Theme");		
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 50, MENU_POS_Y + 20*8, "Old As Hell Theme");
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 50, MENU_POS_Y + 20*9, "No Escape Theme");
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 50, MENU_POS_Y + 20*10, "Mild Hope Theme");
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 50, MENU_POS_Y + 20*11, "Lonely Flowers Theme");
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 50, MENU_POS_Y + 20*12, "Power Grid Theme");			
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 50, MENU_POS_Y + 20*13, "Future Door Theme");
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 50, MENU_POS_Y + 20*14, "Old Paper Theme");
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 50, MENU_POS_Y + 20*15, "Doom's Hive Theme");
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 50, MENU_POS_Y + 20*16, "Crazy Wall Theme");
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 50, MENU_POS_Y + 20*17, "Classic Curves Theme");
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 50, MENU_POS_Y + 20*18, "Super Nova Theme");
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 50, MENU_POS_Y + 20*19, "Mosaic Theme");	
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 35, MENU_POS_Y + 20*(4+selected), ARROW_RIGHT);}
+		//////////
+		if (f_chdir_char("/apps/Nintendont/Preview/black") == FR_OK){
+		Preview();}
+		//////////
+		GRRLIB_Render();
+		FPAD_Update();
+		if (delay > ticks_to_millisecs(gettime())) continue;
+		if (FPAD_Start(1)) {
+			ClearScreen();
+					if (which_bg == BG_NONE)
+					{PrintFormat(DEFAULT_SIZE, BLACK, 212, 232, "Returning to loader...");}
+					else if (which_bg == BG_LEGACY)
+					{PrintFormat(DEFAULT_SIZE, WHITE, 212, 232, "Returning to loader...");}
+			ExitToLoader(0);
+		}
+		if (FPAD_OK(1)) {
+		if (selected <= (DOWNLOAD_15))
+			{
+			f_rename_char( "./NinBack.png", "./NinBack.old");
+			f_rename_char( "./NinBlack.png", "./NinBlack.old");
+			f_rename_char( "./NinLegacy.png", "./NinLegacy.old");
+			Download(selected);
+			f_unlink_char( "./NinBack.old" );
+			f_unlink_char( "./NinBlack.old" );
+			f_unlink_char( "./NinLegacy.old" );
+			BackTheme();
+			FadeIt();
+			goto end;
+			}
+			else
+			break;
+			}
+		if (FPAD_Down(1)) {
+			delay = ticks_to_millisecs(gettime()) + 150;
+			selected++;
+			if (selected > 15) selected = 0;
+		}
+		if (FPAD_Up(1)) {
+			delay = ticks_to_millisecs(gettime()) + 150;
+			selected--;
+			if (selected < 0) selected = 15;
+		}
+		if(FPAD_Y(0)) {
+				Credits();
+		}				
+		if (FPAD_Cancel(1)) {
+			break;
+		}
+	}
+	ClearScreen();
+	UpdateNintendont();
+}
\ No newline at end of file
